# All initial schemas

# --- !Ups

CREATE TABLE users (
  id         INT(11)      NOT NULL PRIMARY KEY AUTO_INCREMENT,
  email      VARCHAR(255) NOT NULL,
  name       VARCHAR(255) NOT NULL,
  password   VARCHAR(255) NOT NULL,
  created_at TIMESTAMP DEFAULT CURRENT_TIMESTAMP
);

CREATE TABLE connections (
  id         INT(11)      NOT NULL PRIMARY KEY AUTO_INCREMENT,
  driver     VARCHAR(50)  NOT NULL,
  `ssl`      TINYINT(1)   NOT NULL DEFAULT 0,
  db         VARCHAR(255) NOT NULL,
  hostname   VARCHAR(255) NOT NULL,
  port       INT(11)      NOT NULL DEFAULT 3306,
  username   VARCHAR(255) NOT NULL,
  password   TEXT,
  created_at TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
  user_id    INT(11)      NOT NULL,
  title      VARCHAR(255) DEFAULT NULL,
  FOREIGN KEY (user_id) REFERENCES users (id)
    ON DELETE CASCADE
    ON UPDATE CASCADE
);

CREATE TABLE queries (
  id         INT(11)      NOT NULL PRIMARY KEY AUTO_INCREMENT,
  conn_id    INT(11)      NOT NULL,
  db         VARCHAR(255) NOT NULL,
  `table`    VARCHAR(255) DEFAULT NULL,
  hash       VARCHAR(40)  NOT NULL,
  query      LONGTEXT     NOT NULL,
  created_at TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
  user_id    INT(11)      NOT NULL,
  FOREIGN KEY (user_id) REFERENCES users (id)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  FOREIGN KEY (conn_id) REFERENCES connections (id)
    ON DELETE CASCADE
    ON UPDATE CASCADE
);

# --- !Downs

DROP TABLE IF EXISTS users;
DROP TABLE IF EXISTS connections;
DROP TABLE IF EXISTS servers;
