define(['underscore', 'backbone', 'helpers/string', 'context', 'moment'], function(_, Backbone, string, Context, Moment) {

	// @todo refactor into a common place, probably should use moment.js in
	// other places too
	Moment.locale('precise-en', {
		relativeTime: {
			future: "In %s",
			past: "%s ago",
			s: function(number) {
				return number === 1 ? 'Less than a second' : number + ' seconds';
			},
			m: "1 minute",
			mm: "%d minutes",
			h: "An hour",
			hh: "%d hours",
			d: "A day",
			dd: "%d days",
			M: "A month",
			MM: "%d months",
			y: "A year",
			yy: "%d years"
		}
	});

	var Backup = Backbone.Model.extend({
		urlRoot: "/backup",
		parse: function(model) {

			// extract root model
			if (model.backup) {
				model = model.backup;
			}

			model.elapsed_f = model.finished_at ? Moment.duration(model.finished_at - model.created_at).locale("precise-en").humanize() : "N/A";
			model.elapsed = model.finished_at ? Moment.duration(model.finished_at - model.created_at).asMilliseconds() : null;

			model.created_at = Moment(new Date(model.created_at)).format("MMMM Do, YYYY, HH:mm:ss");
			model.created_at_f = Moment(new Date(model.created_at)).fromNow();

			model.finished_at = model.finished_at ? Moment(new Date(model.finished_at)).format("MMMM Do, YYYY, HH:mm:ss") : null;
			model.finished_at_f = model.finished_at ? Moment(new Date(model.finished_at)).fromNow() : null;

			return model;
		}
	});
	return Backup;
});
