define(['context', 'models/table/meta'], function (Context, Meta) {
    describe("Table Meta", function () {
        it("should return correct url", function () {

            // context mock object
            Context.connection = 1;
            Context.db = "INFORMATION_SCHEMA";
            Context.table = "ENGINES";

            var m = new Meta();
            var url = "/query/meta/1/INFORMATION_SCHEMA/ENGINES";
            expect(m.url()).toBe(url);
        });
        it("getColumnString should return joined list of columns", function () {
            var m = new Meta({columns: ["id", "foo", "bar"]});
            expect(m.getColumnString()).toBe("id, foo, bar");

            var m = new Meta({columns: ["id"]});
            expect(m.getColumnString()).toBe("id");
        });
	});
});
